PR3287(1)

NAME
pr3287 - IBM host printing tool

SYNOPSIS
pr3287 [ options ] [ L: ] [[ LUname [, LUname ...]@] hostname [: port ]]

DESCRIPTION
pr3287 opens a telnet connection to an IBM host, and emulates an IBM 3287 printer. It implements RFCs 2355 (TN3270E), 1576 (TN3270) and 1646 (LU name selection).

If the hostname is prefixed with L:, the connection will be made through an SSL tunnel. pr3287 also supports TELNET START-TLS option negotiation without any need for command-line options.

A specific LU name to use may be specified by prepending it to the hostname with an `@'. Multiple LU names to try can be separated by commas. An empty LU can be placed in the list with an extra comma.

The port to connect to defaults to telnet. This can be overridden by appending a port to the hostname with a colon `:'.

OPTIONS
pr3287 understands the following options:

-assoc LUname
    Causes the session to be associated with the specified LUname.

-blanklines
    In LU3 formatted mode, print blank lines even if they are all NULLs or control characters. (This is a violation of the 3270 printer protocol, but some hosts require it.)

-charset name
    Specifies an alternate EBCDIC-to-ASCII mapping. The default maps the EBCDIC U.S. English character set to ISO 8859-1. Other built-in character sets include bracket, which corresponds to many older IBM hosts' mapping of the [ and ] characters, and the non-U.S. character sets german, finnish, uk, norwegian, french, icelandic and belgian. These correspond to the x3270 character sets of the same names.

-command command
    Specifies the command to run for each print job. The default is lpr.

-crlf
    Causes newline characters in the output to be expanded to carriage-return/linefeed sequences.

-daemon
    Causes pr3287 to become a daemon (background) process.

-eojtimeout seconds
    Causes pr3287 to flush the print job after seconds seconds of inactivity.

-ignoreeoj
    Ignore TN3270E PRINT-EOJ commands, relying on UNBIND commands to indicate the ends of print jobs.

-ffskip
    Causes pr3287 to ignore a FF (formfeed) order if it occurs at the top of a page.

-ffthru
    In SCS mode, causes pr3287 to pass FF (formfeed) orders through to the printer as ASCII formfeed characters, rather than simulating them based on the values of the MPL (maximum presentation line) and TM (top margin) parameters.

The printer can be the name of a local printer, or a UNC path to a remote printer, e.g., <b>\serverrinter1</b>.

-proxy type:host[:port]
    Causes pr3287 to connect via the specified proxy, instead of using a direct connection. The host can be an IP address or hostname. The optional port can be a number or a service name. For a list of supported proxy types, see PROXY below.

-reconnect
    Causes pr3287 to reconnect to the host, whenever the connection is broken. There is a 5-second delay between reconnect attempts, to reduce network thrashing for down or misconfigured hosts.

-trace
    Turns on data stream tracing. Trace information is usually saved in the file /tmp/x3trc.pid.

-tracedir dir
    Specifies the directory to save trace files in, instead of /tmp.

-trnpre file
    Specifies a file containing data that will be sent to the printer before each print job. The file contents are treated as transparent data, i.e., they are not translated in any way.

-trnpost file
    Specifies a file containing data that will be sent to the printer after each print job. The file contents are treated as transparent data, i.e., they are not translated in any way.

-v  Display build and version information and exit.

SIGNALS
SIGINT, SIGHUP and SIGTERM cause the current print job to be flushed (any pending data to be printed) and pr3287 to exit.

SIGUSR1 causes the current print job to be flushed without otherwise affecting the pr3287 process.

PROXY
The -proxy option causes pr3287 to use a proxy server to connect to the host. The syntax of the option is:
    type:host[:port]
The supported values for type are:
Proxy Type | Protocol | Default Port
http | RFC 2817 HTTP tunnel (squid) | 3128
passthru | Sun in.telnet-gw | none
socks4 | SOCKS version 4 | 1080
socks5 | SOCKS version 5 (RFC 1928) | 1080
telnet | No protocol (just send connect host port) | none

The special types socks4a and socks5d can also be used to force the proxy server to do the hostname resolution for the SOCKS protocol.

SEE ALSO
x3270(1), c3270(1), telnet(1), tn3270(1)
Data Stream Programmer's Reference, IBM GA23-0059
Character Set Reference, IBM GA27-3831
3174 Establishment Controller Functional Description, IBM GA23-0218
RFC 1576, TN3270 Current Practices
RFC 1646, TN3270 Extensions for LUname and Printer Selection
RFC 2355, TN3270 Enhancements

COPYRIGHTS
Copyright 1993-2009, Paul Mattes.
Copyright 1990, Jeff Sparkes.
Copyright 1989, Georgia Tech Research Corporation (GTRC), Atlanta, GA
 30332.
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

*   Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

*   Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

*   Neither the names of Paul Mattes, Jeff Sparkes, GTRC nor the names of their contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY PAUL MATTES, JEFF SPARKES AND GTRC `AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL PAUL MATTES, JEFF SPARKES OR GTRC BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

VERSION
pr3287 3.3.9ga12